export type DeepPartial<T> = T extends Function ? T : T extends object ? {
    [P in keyof T]?: DeepPartial<T[P]>;
} : T;
export type NonMutable<T extends object> = {
    [Key in keyof Omit<T, 'mutate'>]: T[Key] extends object ? NonMutable<T[Key]> : T[Key];
};
export interface Mutable<T extends object, K = any> {
    mutate?: {
        [key: string]: DeepPartial<Mutated<T, K>>;
    };
}
export type Mutated<T extends object, K = any> = {
    [Key in keyof T]: (T[Key] extends object ? Mutated<T[Key]> : T[Key]) | ((this: K, obj: T, ...args: any) => T) | symbol;
};
export type MutableCondition = string | {
    condition: string;
    args?: () => any | any[];
};
export declare const deleteValue: unique symbol;
export declare function applyMutation<T extends Mutable<NonMutable<T>>>(conditions: MutableCondition[], obj: T): T;
